原题链接: ​​http://acm.hdu.edu.cn/showproblem.php?pid=5119​



Problem Description


Matt has N friends. They are playing a game together.

Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins.

Matt wants to know the number of ways to win.


 



Input


The first line contains only one integer T , which indicates the number of test cases.

For each test case, the first line contains two integers N, M (1 ≤ N ≤ 40, 0 ≤ M ≤ 10 6).

In the second line, there are N integers ki (0 ≤ k i ≤ 10 6), indicating the i-th friend’s magic number.


 



Output


For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1) and y indicates the number of ways where Matt can win.


 



Sample Input


2 3 2 1 2 3 3 3 1 2 3


 



Sample Output


Hint

In the first sample, Matt can win by selecting:

friend with number 1 and friend with number 2. The xor sum is 3. friend with number 1 and friend with number 3. The xor sum is 2. friend with number 2. The xor sum is 2. friend with number 3. The xor sum is 3. Hence, the answer is 4.




有N个人,每个人有一个权值,你可以挑任意多的人并将他们的权值异或(也可以不选),求最后得到的值大于M的取法有多少种。



解法:


N范围为40,权值范围为10^6 约等于2的20次方,可以考虑类似背包+位运算的做法。因为异或值一定不会大于2^20,所以可以枚举这个值,对每个状态,来源有两个——一是上一个阶段不取,二是取a[i],所以可以列出方程f[i][j]=f[i][j]+f[i][j^a[i]]; 最后计算即可。




#include <iostream>    
#include <stdio.h>
#include <string>
#include <string.h>
#include <algorithm>
using namespace std;
typedef long long ll;

const int maxn = 1 << 20;
int n, m, test;
int a[45];
ll dp[44][maxn];

ll solve()
{
memset(dp, 0, sizeof(dp));
dp[1][0] = dp[1][a[1]] = 1;
for (int i = 2; i <= n; i++)
for (int j = 0; j < maxn; j++)
dp[i][j] = dp[i - 1][j] + dp[i - 1][j^a[i]];

ll ans = 0;
for (int i = m; i < maxn; i++)
ans += dp[n][i];
return ans;
}

int main()
{
int T, test = 1;
scanf("%d", &T);
while (T--)
{
scanf("%d%d", &n, &m);
for (int i = 1; i <= n; i++)
scanf("%d", &a[i]);

ll ans = solve();
printf("Case #%d: %lld\n", test++, ans);
}
return 0;
}